#include "MapEditorMainFrame.h"
#include "AnnotationDialog.h"


////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
/**
    E{^ƂɌĂ΂
*/
void MapEditorMainFrame::OnRightDown(wxMouseEvent& ev)
{
    //J[\ݒ
    wxGetApp().setCursor();
    int mx = ev.m_x;
    int my = ev.m_y;
    //}EXWL^
    hpl::aleph::view::HPLViewGridManager* vmgr = wxGetApp().getViewGridManager();
    vmgr->setNewMousePoint(mx, my);

	//XgbN}l[W[
	hpl::aleph::HPLStockManager* smgr = wxGetApp().getStockManager();

    //|bvAbvj[o
    //TODO
    //}EXW[hWɂ
    hpl::aleph::HPLEventManager* emgr = wxGetApp().getEventManager();
    int div = vmgr->getZoomDivision();
    int zMin = vmgr->getViewHeightMin();
    int zMax = vmgr->getViewHeightMax();

    int editMode = emgr->getEditModeType();
    int toolType = emgr->getToolType();
	int voffset[2];
	vmgr->getOffset(voffset);

	hpl::aleph::map::HPLSelectData* sel = &wxGetApp().selectData;

	hpl::aleph::map::HPLDoneHistory* dmgr = wxGetApp().getDoneHistoryManager();

    if(editMode == EditModeType::EM_DRAW && toolType == ToolType::TI_ARROW){
		if(sel->isSelected() && emgr->isGrabItems()){
			//{^ȂE
			if(sel->isSelected()){
				//IĂ
				if(emgr->isGrabItems()){
					//ł

					//ł̂͂Ȃ
					emgr->setGrabItems(false);

					//Ẅʒuɖ߂
					hpl::aleph::map::HPLSelectData dummy1;
					hpl::aleph::map::HPLRealMapData dummy2;
					hpl::aleph::map::HPLActionItem act = hpl::aleph::map::HPLActionItem(0, dummy1, dummy2);
					dmgr->getTail(&act);
					int lastMousePosition[2];
					act.selectData.getMousePosition(lastMousePosition);
					world_point2d worldLastMousePosition = 
						wxGetApp().getWorldPointFromViewPoint(
							lastMousePosition[0], lastMousePosition[1]);
					hpl::aleph::map::HPLSelectData* actSel = &act.selectData;
					//points
					for(int i = 0; i < (int)actSel->getSelPoints()->size(); i ++){
						hpl::aleph::map::SelPoint* selp = &actSel->getSelPoints()->at(i);
						endpoint_data* ep = get_endpoint_data(selp->index);
						ep->vertex.x = worldLastMousePosition.x + selp->offset[0] * div;
						ep->vertex.y = worldLastMousePosition.y + selp->offset[1] * div;
					}

					//lines
					for(int i = 0; i < (int)actSel->getSelLines()->size(); i ++){
						hpl::aleph::map::SelLine* sell = &actSel->getSelLines()->at(i);
						line_data* line = get_line_data(sell->index);
						for(int j = 0; j < 2; j ++){
							endpoint_data* ep = get_endpoint_data(line->endpoint_indexes[j]);
							ep->vertex.x = worldLastMousePosition.x + sell->offset[j][0] * div;
							ep->vertex.y = worldLastMousePosition.y + sell->offset[j][1] * div;
						}
					}

					//polygons
					for(int i = 0; i < (int)actSel->getSelPolygons()->size(); i ++){
						hpl::aleph::map::SelPolygon* selp = &actSel->getSelPolygons()->at(i);
						polygon_data* poly = get_polygon_data(selp->index);
						int n = poly->vertex_count;
						for(int j = 0; j < n; j ++){
							endpoint_data* ep = get_endpoint_data(poly->endpoint_indexes[j]);
							ep->vertex.x = worldLastMousePosition.x + selp->offset[j][0] * div;
							ep->vertex.y = worldLastMousePosition.y + selp->offset[j][1] * div;
						}
					}

					//objects
					for(int i = 0; i < (int)actSel->getSelObjects()->size(); i ++){
						hpl::aleph::map::SelObject* selp = &actSel->getSelObjects()->at(i);
						map_object* obj = &SavedObjectList[selp->index];
						obj->location.x = worldLastMousePosition.x + selp->offset[0] * div;
						obj->location.y = worldLastMousePosition.y + selp->offset[1] * div;
					}

					//annotations
					for(int i = 0; i < (int)actSel->getSelAnnotations()->size(); i ++){
						hpl::aleph::map::SelAnnotation* selp =
							&actSel->getSelAnnotations()->at(i);
						map_annotation* annotation = &MapAnnotationList[selp->index];
						annotation->location.x =
							worldLastMousePosition.x + selp->offset[0] * div;
						annotation->location.y =
							worldLastMousePosition.y + selp->offset[1] * div;
					}
					Refresh();
				}
			}
		}else{
			//_̏ŉENbNH
			int epIndex = hpl::aleph::map::getSelectPointIndex(mx ,my,
				POINT_DISTANCE_EPSILON, zMin, zMax,
				voffset[0], voffset[1], OFFSET_X_WORLD, OFFSET_Y_WORLD, div, 
				smgr);
			wxGetApp().popupEndpointIndex = epIndex;
			int lineIndex = hpl::aleph::map::getSelectLineIndex(mx ,my,
				LINE_DISTANCE_EPSILON, zMin, zMax,
				voffset[0], voffset[1], OFFSET_X_WORLD, OFFSET_Y_WORLD, div, 
				smgr);
			wxGetApp().popupLineIndex = lineIndex;
			int polygonIndex = hpl::aleph::map::getSelectPolygonIndex(mx ,my,
				zMin, zMax,
				voffset[0], voffset[1], OFFSET_X_WORLD, OFFSET_Y_WORLD, div, 
				smgr);
			wxGetApp().popupPolygonIndex = polygonIndex;
			if(hpl::aleph::map::isValidIndex(epIndex, EndpointList.size())){
				//IύX
				selectOneThingBefore();
				int offset[2] = {0};
				sel->addSelPoint(epIndex, offset);
				selectOneThingAfter(mx, my);
				//I̍XV
				smgr->updateSelects(wxGetApp().selectData);
				Refresh();
				//_|bvAbv\
				PopupMenu(&wxGetApp().pointPopupMenu);
			}else if(hpl::aleph::map::isValidIndex(lineIndex, LineList.size())){
				//ꂽ
				//IύX
				selectOneThingBefore();
				int offset[2][2] = {{0}};
				sel->addSelLine(lineIndex, offset);
				selectOneThingAfter(mx, my);
				//I̍XV
				smgr->updateSelects(wxGetApp().selectData);
				Refresh();
				//vpeB
				PopupMenu(&wxGetApp().linePopupMenu);
			}else if(hpl::aleph::map::isValidIndex(polygonIndex, PolygonList.size())){
				//
				//IύX
				selectOneThingBefore();
				polygon_data* poly = get_polygon_data(polygonIndex);
				int offset[MAXIMUM_VERTICES_PER_POLYGON][2] = {{0}};
				int num = poly->vertex_count;
				sel->addSelPolygon(polygonIndex, offset, num);
				selectOneThingAfter(mx, my);
				//I̍XV
				smgr->updateSelects(wxGetApp().selectData);
				Refresh();
				PopupMenu(&wxGetApp().polygonPopupMenu);
			}
		}
    }
	//ݒ
	emgr->setGrabItems(false);
}
///////////////////////////////////////////////////////
void MapEditorMainFrame::OnRightUp(wxMouseEvent& ev)
{
    //J[\ݒ
    wxGetApp().setCursor();
    int mx = ev.m_x;
    int my = ev.m_y;

    //}EXWL^
    wxGetApp().getViewGridManager()->setNewMousePoint(mx, my);


}
void MapEditorMainFrame::OnLeftUp(wxMouseEvent& ev)
{
    //J[\ݒ
    wxGetApp().setCursor();
    //}EXWL^
    wxGetApp().getViewGridManager()->setNewMousePoint(ev.m_x, ev.m_y);

    //Cxg}l[W[
    hpl::aleph::HPLEventManager* emgr = wxGetApp().getEventManager();

    int editMode = emgr->getEditModeType();
    int toolType = emgr->getToolType();
    if(editMode == EditModeType::EM_DRAW){
        if(toolType == ToolType::TI_ARROW){
            this->doLUpOnArrowTool(ev);
        }else if(toolType == ToolType::TI_POLYGON){
            this->doLUpOnPolygonTool(ev);
        }
    }
    emgr->exitSelectingGroup();

    //|SԂXV܂
    wxGetApp().getStockManager()->updatePolygonValidityStored();
	//I̍XV
	wxGetApp().getStockManager()->updateSelects(wxGetApp().selectData);

    Refresh();
}

void MapEditorMainFrame::doLUpOnArrowTool(wxMouseEvent& ev)
{
    //If[^
    hpl::aleph::map::HPLSelectData* sel = &wxGetApp().selectData;

    //Obh}l[W[
    hpl::aleph::view::HPLViewGridManager* vmgr = wxGetApp().getViewGridManager();
    hpl::aleph::HPLEventManager* emgr = wxGetApp().getEventManager();
	hpl::aleph::map::HPLDoneHistory* dmgr = wxGetApp().getDoneHistoryManager();
	hpl::aleph::HPLStockManager* smgr = wxGetApp().getStockManager();

	int zMin = vmgr->getViewHeightMin();
	int zMax = vmgr->getViewHeightMax();
	int div = vmgr->getZoomDivision();
	int voffset[2];
	vmgr->getOffset(voffset);

	//łsɎc
	if(sel->isSelected() && emgr->isGrabItems()){
		dmgr->push_back(
			hpl::aleph::map::ActionType::Move, *sel);

		//IuWFNg̈ړɃ|SȂꍇAUndo邩
		//_CAOoB
		std::vector<int> deleteObjectIndexes;

		for(int i = 0; i < (int)sel->getSelObjects()->size(); i ++){
			int index = sel->getSelObjects()->at(i).index;
			map_object* obj = &SavedObjectList[index];
			int wx = obj->location.x;
			int wy = obj->location.y;
			world_point2d wpoint;
			wpoint.x = wx;
			wpoint.y = wy;
			int vpoint[2];
			wxGetApp().getViewPointFromWorldPoint(wpoint, vpoint);
			//|S̏ɂ邩`FbN
			int polyIndex = hpl::aleph::map::getSelectPolygonIndex(vpoint[0], vpoint[1],
				zMin, zMax, voffset[0], voffset[1], OFFSET_X_WORLD, OFFSET_Y_WORLD,
				div, smgr);
			if(polyIndex == NONE){
				deleteObjectIndexes.push_back(index);
			}
		}
		if(deleteObjectIndexes.size() > 0){
			int result = wxMessageBox(_T("Some objects are out of polygon. Whether you delete them or cancel moving?"),
				_T("Caution"), wxOK | wxCANCEL);
			if(result == wxOK){
				//Ώۂ폜
				for(int i = 0; i < (int)deleteObjectIndexes.size(); i ++){
					smgr->deleteObject(deleteObjectIndexes[i]);
				}
			}else{
				//LZ
				wxCommandEvent dummy;
				this->OnUndo(dummy);
			}
		}
	}
    if(sel->isSelectOneObject()){
        //IuWFNgIĂ
        //IuWFNg_CAO\
        //TODO
        this->objPropDialog.Show(true);
    }else if(sel->isSelectOnePolygon()){
        //|S_CAO\
    }
    //TODO
    //_AASide͉ENbNj[ŃvpeBÎݕ\
    
    int mx = ev.m_x;
    int my = ev.m_y;

	//ŏɑIڂɒǉꂽ
	bool isFirst = true;

	//ݒ
	emgr->setGrabItems(false);

    if(emgr->isSelectingGroup()){

        //͈͑I𒆂B`̃ACeIƂ
        //IJnʒu
        int selStartPoint[2];
        emgr->getSelectGroupStartPoint(selStartPoint);
        
        //_ <en> points
        for(int i = 0; i < (int)EndpointList.size(); i ++){
            endpoint_data* ep = get_endpoint_data(i);
            //`FbN
            if(!vmgr->isValidHeight(ep->highest_adjacent_floor_height,
                ep->lowest_adjacent_ceiling_height))
            {
                continue;
            }
            int vpoint[2];
            wxGetApp().getViewPointFromWorldPoint(ep->vertex, vpoint);
            if(hpl::math::isPointInRect<int>(vpoint[0], vpoint[1],
                mx, my, selStartPoint[0], selStartPoint[1]))
            {
				if(isFirst){
					isFirst = false;
					sel->clear();
				}
                //ǉ
                int offset[2] = {0,0};
                sel->addSelPoint(i, offset);
            }
        }

        // <en> lines
        for(int i = 0; i < (int)LineList.size(); i ++){
            line_data* line = get_line_data(i);
            endpoint_data* begin = get_endpoint_data(line->endpoint_indexes[0]);
            endpoint_data* end = get_endpoint_data(line->endpoint_indexes[1]);
            int beginVPoint[2];
            int endVPoint[2];
            wxGetApp().getViewPointFromWorldPoint(begin->vertex, beginVPoint);
            wxGetApp().getViewPointFromWorldPoint(end->vertex, endVPoint);

            //`FbN
            if(!vmgr->isValidHeight(line->highest_adjacent_floor,
                line->lowest_adjacent_ceiling))
            {
                continue;
            }
            if(hpl::math::isLineInRect(beginVPoint[0], beginVPoint[1],
                endVPoint[0], endVPoint[1],
                mx, my, selStartPoint[0], selStartPoint[1]))
            {
				if(isFirst){
					isFirst = false;
					sel->clear();
				}
                //ǉ
                int offset[2][2] = {{0,0},{0,0}};
                sel->addSelLine(i, offset);
            }
        }

        //|S
        for(int i = 0; i < (int)PolygonList.size(); i ++){
            polygon_data* poly = get_polygon_data(i);
            int n = poly->vertex_count;
            if(n < 1 || n >= MAXIMUM_VERTICES_PER_POLYGON){
                continue;
            }
            //`FbN
            if(!vmgr->isValidHeight(poly->floor_height,
                poly->ceiling_height))
            {
                continue;
            }
            //SĂ̓_`Ȃ|SI
            bool inner = true;
            for(int j = 0; j < n; j ++){
                endpoint_data* ep = get_endpoint_data(poly->endpoint_indexes[j]);
                int vpoint[2];
                wxGetApp().getViewPointFromWorldPoint(ep->vertex, vpoint);
                if(!hpl::math::isPointInRect<int>(vpoint[0], vpoint[1],
                    mx, my, selStartPoint[0], selStartPoint[1]))
                {
                    inner = false;
                    break;
                }
            }
            if(inner){
				if(isFirst){
					isFirst = false;
					sel->clear();
				}
                //o^
				int offset[MAXIMUM_VERTICES_PER_POLYGON][2] = {{0}};
                memset(offset, 0, sizeof(int) * MAXIMUM_VERTICES_PER_POLYGON * 2);
                sel->addSelPolygon(i, offset, n);
            }
        }
    

        //IuWFNg
        for(int i = 0; i < (int)SavedObjectList.size(); i ++){
            map_object* obj = &(SavedObjectList[i]);
            //`FbN
            if(!vmgr->isValidHeight(obj->location.z,
                obj->location.z))
            {
                continue;
            }
            int vpoint[2];
            wxGetApp().getViewPointFromWorldPoint(obj->location.x, 
                obj->location.y, vpoint);
            if(hpl::math::isPointInRect<int>(vpoint[0], vpoint[1],
                mx, my, selStartPoint[0], selStartPoint[1]))
            {
				if(isFirst){
					isFirst = false;
					sel->clear();
				}
                //ǉ
                int offset[2] = {0,0};
                sel->addSelObject(i, offset);
            }
        }

    }
	//ǂIĂȂ`FbN
	if(isFirst && !sel->isSelected()){
		//IĂȂ

		//Öʒu
		int oldVPoint[2];
		wxGetApp().getViewGridManager()->getOldMousePoint(oldVPoint);
		
		//݂̈ʒuƂ̋vZ
		double distance = hpl::math::getLength(mx - oldVPoint[0], my - oldVPoint[1]);
		if(distance > SAME_POSITION_CLICK_THRESHOLD){
			//قڌ݂̈ʒuŃNbN
			//	ȂΑI
			sel->clear();
		}
	}

	/*
	if(sel->isSelected()){
		//Rsyo^
		wxGetApp().getDoneHistoryManager()->push_back(hpl::aleph::map::ActionType::Move, *sel);
	}
	*/
	//
	emgr->setGrabItems(false);
}
void MapEditorMainFrame::doLUpOnPolygonTool(wxMouseEvent& ev)
{
    int selStartPoint[2];
    wxGetApp().getEventManager()->getSelectGroupStartPoint(selStartPoint);
    hpl::aleph::HPLEventManager* emgr = wxGetApp().getEventManager();
    if(emgr->isSelectingGroup()){
		//Kvɍ킹ăObhW擾
		int mx = ev.m_x;
		int my = ev.m_y;
		int vStartPoint[2];
		int vEndPoint[2];
		this->getGridedViewPoint(mx, my, vStartPoint);
		this->getGridedViewPoint(selStartPoint, vEndPoint);
        //np`̍WvZ
        double polyPointsView[MAXIMUM_VERTICES_PER_POLYGON][2];
        int n = wxGetApp().presetPolygonVertexCount;
        hpl::math::getRectangleScaledPreparedPolygon(vStartPoint[0], vStartPoint[1],
            vEndPoint[0], vEndPoint[1], n,
            polyPointsView);
        //[hW`ɕϊ
        world_point2d polyPointsWorld[MAXIMUM_VERTICES_PER_POLYGON];
        for(int i = 0; i < n; i ++){
            polyPointsWorld[i] = wxGetApp().getWorldPointFromViewPoint(
                (int)polyPointsView[i][0], (int)polyPointsView[i][1]);
        }
        //|S
        hpl::aleph::map::addNewPolygon(polyPointsWorld, n);
        //XV
        wxGetApp().getStockManager()->updateDeletes();
    }
}

/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
/**
    }EXړƂɌĂ΂
*/
void MapEditorMainFrame::OnMotion(wxMouseEvent &ev)
{
    //J[\ݒ
    wxGetApp().setCursor();

    //}EXWL^
    wxGetApp().getViewGridManager()->setNewMousePoint(ev.m_x, ev.m_y);

    int editModeType = wxGetApp().getEventManager()->getEditModeType();

    const int UPDATE_POLYGON_VALIDITY_INTERVAL = 10;
    static int updatePolygonValidityCount = UPDATE_POLYGON_VALIDITY_INTERVAL;

    //|S`FbNJEg
    updatePolygonValidityCount ++;


    int mx = ev.m_x;
    int my = ev.m_y;
    int toolType = wxGetApp().getEventManager()->getToolType();
#ifdef MAPVIEWER
    if(ev.ButtonIsDown(wxMOUSE_BTN_LEFT)){
        if(updatePolygonValidityCount >= UPDATE_POLYGON_VALIDITY_INTERVAL){
            //|SXV
            wxGetApp().getStockManager()->updatePolygonValidityStored();
        }

        //{^Ȃ瓮Ă
        bool shift = ev.ShiftDown();
        bool ctrl = ev.ControlDown();
		//Viewerp̓
		//NbNĂΈړ
		if(ctrl ||
			editModeType == EditModeType::EM_DRAW && toolType == ToolType::TI_HAND)
		{
			//ItZbgړ
			moveMapOffset(mx, my);
		}
        Refresh();
	}
#else
    if(ev.ButtonIsDown(wxMOUSE_BTN_LEFT)){
        if(updatePolygonValidityCount >= UPDATE_POLYGON_VALIDITY_INTERVAL){
            //|SXV
            wxGetApp().getStockManager()->updatePolygonValidityStored();
			updatePolygonValidityCount = 0;
        }

        //{^Ȃ瓮Ă
        bool shift = ev.ShiftDown();
        bool ctrl = ev.ControlDown();

        //ҏW[hƂɓ삪قȂ
        
        
        if(ctrl ||
            editModeType == EditModeType::EM_DRAW && toolType == ToolType::TI_HAND)
        {
            //Rg[ȂA
            //邢̓nhc[D&D
            //ItZbgړ
            this->moveMapOffset(ev.m_x, ev.m_y);
        }else{
            //CtrlȂ

            switch(editModeType){
            case EditModeType::EM_DRAW:
                doMouseMotionOnDrawMode(ev);
                break;
            case EditModeType::EM_POLYGON_TYPE:
                doMouseMotionOnPolygonMode(ev);
                break;
            case EditModeType::EM_FLOOR_HEIGHT:
                doMouseMotionOnFloorHeightMode(ev);
                break;
            case EditModeType::EM_CEILING_HEIGHT:
                doMouseMotionOnCeilingHeightMode(ev);
                break;
            case EditModeType::EM_FLOOR_LIGHT:
                doMouseMotionOnFloorLightMode(ev);
                break;
            case EditModeType::EM_CEILING_LIGHT:
                doMouseMotionOnCeilingLightMode(ev);
                break;
            case EditModeType::EM_MEDIA:
                doMouseMotionOnMediaMode(ev);
                break;
            case EditModeType::EM_FLOOR_TEXTURE:
                doMouseMotionOnFloorTextureMode(ev);
                break;
            case EditModeType::EM_CEILING_TEXTURE:
                doMouseMotionOnCeilingTextureMode(ev);
                break;
            }
        }


        Refresh();
    }else{
        //ĂȂ
        if(editModeType == EditModeType::EM_DRAW &&
            wxGetApp().getEventManager()->getToolType() == ToolType::TI_LINE)
        {
            this->doMouseMotionOnLineTool(ev);
        }
    }
#endif

    //XV
    wxGetApp().getViewGridManager()->setNewMousePoint(ev.m_x, ev.m_y);

}
void MapEditorMainFrame::doMouseMotionOnDrawMode(wxMouseEvent& ev)
{
    switch(wxGetApp().getEventManager()->getToolType()){
    case ToolType::TI_ARROW:
        doMouseMotionOnArrowTool(ev);
        break;
    case ToolType::TI_FILL:
        doMouseMotionOnFillTool(ev);
        break;
    case ToolType::TI_HAND:
        doMouseMotionOnHandTool(ev);
        break;
    case ToolType::TI_LINE:
        //c[D&D͍lȂ
        //doMouseMotionOnLineTool(ev);
        break;
    case ToolType::TI_MAGNIFY:
        doMouseMotionOnMagnifyTool(ev);
        break;
    case ToolType::TI_SKULL:
        doMouseMotionOnSkullTool(ev);
        break;
    case ToolType::TI_TEXT:
        doMouseMotionOnTextTool(ev);
        break;
    case ToolType::TI_POLYGON:
        doMouseMotionOnPolygonTool(ev);
        break;
    default:
        hpl::error::halt("Invalid tool type");
    }
}
void MapEditorMainFrame::doMouseMotionOnArrowTool(wxMouseEvent& ev)
{
    //͈͑I𒆂ȂH
    //ł邱Ƃ͂Ȃ

    //I𒆂̃}bvACe΁Aړ
    
    //I
    hpl::aleph::map::HPLSelectData* sel = &wxGetApp().selectData;

    hpl::aleph::view::HPLViewGridManager* vmgr = wxGetApp().getViewGridManager();
    int div = vmgr->getZoomDivision();

	hpl::aleph::HPLEventManager* emgr = wxGetApp().getEventManager();

    int mx = ev.m_x;
    int my = ev.m_y;

    if(sel->isSelected() && emgr->isGrabItems()){
        //I
        //I𕨂̈ړ
        
		//}EX臒lȏ㓮ĂACe𓮂
		//}EXŌɑIW
		int lastMousePosition[2];
		sel->getMousePosition(lastMousePosition);
		if(hpl::math::getLength(mx - lastMousePosition[0], my - lastMousePosition[1])
			>SAME_POSITION_CLICK_THRESHOLD)
		{
			//[hWnɂ
			world_point2d wmp = wxGetApp().getWorldPointFromViewPoint(mx, my);

			//KvȂ΃ObhWɂ킹WB
			//Kvǂ̔fsĂ邽߂Ƃ肠Ăяo΂悢B
			wmp = this->getGridedWorldPoint(wmp);

			//_
			for(int i = 0; i < (int)sel->getSelPoints()->size(); i ++){
				struct hpl::aleph::map::SelPoint* selp = &sel->getSelPoints()->at(i);
				int index = selp->index;
				//ʒuύX
				get_endpoint_data(index)->vertex.x = wmp.x + selp->offset[0] * div;
				get_endpoint_data(index)->vertex.y = wmp.y + selp->offset[1] * div;

			}

			//
			for(int i = 0; i < (int)sel->getSelLines()->size(); i ++){
				struct hpl::aleph::map::SelLine* sell = &sel->getSelLines()->at(i);
				int index = sell->index;
				line_data* line = get_line_data(index);
				for(int j = 0; j < 2; j ++){
					get_endpoint_data(line->endpoint_indexes[j])->vertex.x =
						wmp.x + sell->offset[j][0] * div;
					get_endpoint_data(line->endpoint_indexes[j])->vertex.y =
						wmp.y + sell->offset[j][1] * div;
				}
			}

			//|S
			for(int i = 0; i < (int)sel->getSelPolygons()->size(); i ++){
				struct hpl::aleph::map::SelPolygon* selp = &sel->getSelPolygons()->at(i);
				polygon_data* poly = get_polygon_data(selp->index);
				for(int j = 0; j < selp->num; j ++){
					get_endpoint_data(poly->endpoint_indexes[j])->vertex.x =
						wmp.x + selp->offset[j][0] * div;
					get_endpoint_data(poly->endpoint_indexes[j])->vertex.y =
						wmp.y + selp->offset[j][1] * div;
				}
			}

			//IuWFNg
			for(int i = 0; i < (int)sel->getSelObjects()->size(); i ++){
				struct hpl::aleph::map::SelObject* selo = &sel->getSelObjects()->at(i);
				SavedObjectList[selo->index].location.x = wmp.x + selo->offset[0] * div;
				SavedObjectList[selo->index].location.y = wmp.y + selo->offset[1] * div;
			}

			//Ame[V
			//<en> annotation string
			for(int i = 0; i < (int)sel->getSelAnnotations()->size(); i ++){
				hpl::aleph::map::SelAnnotation* sela = &sel->getSelAnnotations()->at(i);
				MapAnnotationList[sela->index].location.x = wmp.x + sela->offset[0] * div;
				MapAnnotationList[sela->index].location.y = wmp.y + sela->offset[1] * div;
			}
		}
    }
}
void MapEditorMainFrame::doMouseMotionOnFillTool(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnHandTool(wxMouseEvent& ev)
{
    //ړ
    this->moveMapOffset(ev.m_x, ev.m_y);
}
/**
    c[
*/
void MapEditorMainFrame::doMouseMotionOnLineTool(wxMouseEvent& ev)
{
    hpl::aleph::view::HPLViewGridManager* vmgr = wxGetApp().getViewGridManager();

    int voffset[2];
    vmgr->getOffset(voffset);
    world_point2d wmp = wxGetApp().getWorldPointFromViewPoint(ev.m_x, ev.m_y);
    int zMin = vmgr->getViewHeightMin();
    int zMax = vmgr->getViewHeightMax();
    int div = vmgr->getZoomDivision();

    //_𓥂łȂmF
    int endpointIndex = hpl::aleph::map::getSelectPointIndex(wmp, 
        POINT_DISTANCE_EPSILON , zMin, zMax, div, wxGetApp().getStockManager());
    if(hpl::aleph::map::isValidIndex(endpointIndex, EndpointList.size())){
        wxGetApp().isNowOnThePoint = true;
        wxGetApp().isNowOnTheLine = false;
    }else{
        wxGetApp().isNowOnThePoint = false;

        int lineIndex = hpl::aleph::map::getSelectLineIndex(wmp,
            LINE_DISTANCE_EPSILON, zMin, zMax, div, wxGetApp().getStockManager());
        if(hpl::aleph::map::isValidIndex(lineIndex, LineList.size())){
            wxGetApp().isNowOnTheLine = true;
        }else{
            wxGetApp().isNowOnTheLine = false;
        }
    }
}
void MapEditorMainFrame::doMouseMotionOnMagnifyTool(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnSkullTool(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnTextTool(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnPolygonTool(wxMouseEvent& ev)
{
}

void MapEditorMainFrame::doMouseMotionOnPolygonMode(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnFloorHeightMode(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnCeilingHeightMode(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnFloorLightMode(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnCeilingLightMode(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnMediaMode(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnFloorTextureMode(wxMouseEvent& ev)
{
}
void MapEditorMainFrame::doMouseMotionOnCeilingTextureMode(wxMouseEvent& ev)
{
}

void MapEditorMainFrame::OnMouseWheel(wxMouseEvent &ev)
{
    //J[\ݒ
    wxGetApp().setCursor();

    int zDelta = ev.m_wheelRotation;
    hpl::aleph::view::HPLViewGridManager* mgr = wxGetApp().getViewGridManager();

    //Rg[L[
    bool ctrl = ev.ControlDown();
    if(ctrl){
        wxSize size = wxFrame::GetSize();
        if(zDelta < 0){
            mgr->zoomIn(size.GetWidth(), size.GetHeight());
        }else{
            mgr->zoomOut(size.GetWidth(), size.GetHeight());
        }
        Refresh();
    }
}

// ItZbgw肵}EX|CgɂĈړ܂
void MapEditorMainFrame::moveMapOffset(int x, int y)
{
    hpl::aleph::view::HPLViewGridManager* mgr = wxGetApp().getViewGridManager();
    //ȑÕ}EX|WV𓾂܂
    int oldMPoint[2];
    mgr->getOldMousePoint(oldMPoint);
    int deltaX = x - oldMPoint[0];
    int deltaY = y - oldMPoint[1];

    //ItZbgݒ肵܂
    int voffset[2];
    mgr->getOffset(voffset);
    voffset[0] += deltaX;
    voffset[1] += deltaY;
    mgr->setOffset(voffset[0], voffset[1]);
}
/////////////////////////////////////////////////
/////////////////////////////////////////////////
//  _uNbN <en> Mouse Left Button Double Click
void MapEditorMainFrame::OnLeftDoubleClick(wxMouseEvent& ev)
{
    //J[\ݒ
    wxGetApp().setCursor();

    hpl::aleph::HPLEventManager* emgr = wxGetApp().getEventManager();
    int editMode = emgr->getEditModeType();
    int toolType = emgr->getToolType();
    if(editMode == EditModeType::EM_DRAW &&
        toolType == ToolType::TI_LINE)
    {
        //[hŃ_uNbN

        //̒ǉ
        this->doLButtonOnLineTool(ev);

        //ҏW̏
        wxGetApp().resetLineEditInfo();
    }

    Refresh();
}

//L[_E
void MapEditorMainFrame::OnKeyDown(wxKeyEvent& ev)
{
	bool ctrl = ev.ControlDown();
	bool shift = ev.ShiftDown();
	//alt or apple/command key ;)
	bool alt = ev.AltDown() || ev.CmdDown();
	
	int code = ev.GetKeyCode();
	wxCommandEvent dummy;
	//memset(&dummy, 0, sizeof(wxCommandEvent));

	if(ctrl){
		if(code == 'C'){
#ifndef MAP_VIEWER
			//Copy!
			this->OnCopy(dummy);
#endif
		}else if(code == 'V'){
#ifndef MAP_VIEWER
			//Paste!
			this->OnPaste(dummy);
#endif
		}else if(code == 'Z'){
#ifndef MAP_VIEWER
			//Undo!
			this->OnUndo(dummy);
#endif
		}else if(code == 'S'){
			if(shift){
				//Save As!
				this->OnSaveAs(dummy);
			}else{
				//Save!
				this->OnSave(dummy);
			}
		}else if(code == 'O'){
			this->OnOpen(dummy);
		}
	}else{
		if(code == WXK_DELETE){
			wxCommandEvent dummy;
			OnDelete(dummy);
		}
	}
	Refresh();
}

/**
	}bvf[^ɕҏWꍇɍs鏈Lq܂
	E_//Side/IuWFNg/|S̃vpeB_CAOč\ziǉ݂̂OKj
	EI̍XV
	E폜̍XV
*/
void MapEditorMainFrame::updateMapItems()
{
	hpl::aleph::HPLStockManager* smgr = wxGetApp().getStockManager();
	smgr->updateSelects(wxGetApp().selectData);
	smgr->updateDeletes();
	smgr->updatePolygonValidityStored();

	//[hX_CAO
	//|SvpeB
	//this->polyPropDialog.updateCombo();

	//|SEFixs
	/*
	for(int i = 0; i < (int)LineList.size(); i ++){
		if(smgr->isDeleteLine(i)){
			continue;
		}
		hpl::aleph::map::fixLine(i, smgr);
	}
	for(int i = 0; i < (int)PolygonList.size(); i ++){
		if(smgr->isDeletePolygon(i)){
			continue;
		}
		hpl::aleph::map::fixPolygon(i, smgr);
	}*/

	//ҏWm点
	wxGetApp().isChanged = true;
	Refresh();

}


//I
void MapEditorMainFrame::OnClose(wxCloseEvent& ev)
{
	//ҏWۑĂȂΖ₢܂
	int result = this->askDestructMap();
	if(result == wxID_YES){
		//ۑ܂
		wxCommandEvent dummy;
		OnSaveAs(dummy);
	}else if(result = wxID_NO){
		Close(true);
	}else{
		//cancel
		//
	}
}
